# -*- coding: ISO-8859-1 -*-

############################################################################## 
## 2004, Arnulf Heimsbakk
## 
## THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS "AS IS"
## AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE 
## IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE
## ARE DISCLAIMED. IN NO EVENT SHALL THE AUTHOR OR CONTRIBUTORS BE LIABLE FOR 
## ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL 
## DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR 
## SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER 
## CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT 
## LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY 
## OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF 
## SUCH DAMAGE.
##
## Otherwise the GPL license: http://www.gnu.org/licenses/gpl.txt
##############################################################################

from PIL import Image, ImageEnhance

class Effect:
    def __init__(self, alpha=0):
        self.alpha = alpha
        self.name = "None"

    def __str__(self):
        return self.name
        
    def __call__(self, image):
        if not self.alpha and image.mode != 'RGB':
            return image.convert('RGB')
        return image

class BlackAndWhite(Effect):
    def __init__(self, alpha=0):
        Effect.__init__(self, alpha)
        self.name = "Black and white"    

    def __call__(self, image):
        enhancer = ImageEnhance.Color(image) 
        return enhancer.enhance(0)
        
class Dimmed50(Effect):
    def __init__(self, alpha=0):
        Effect.__init__(self, alpha)
        self.name = "Colours dimmed 50%"    

    def __call__(self, image):
        enhancer = ImageEnhance.Color(image) 
        return enhancer.enhance(0.5)
